
Setup_Sprites:
	stw   #$20,sx	; that will center it on the screen
	stw   #$40,sy
	lda	#$00
	sta	sprite_no
		lda   #LOW((SPRIT_VRAM) >> 5)
		sta   spr_vram_point
		lda   #HIGH((SPRIT_VRAM) >> 5)
		sta   spr_vram_point+1		;Point to sprites.  What shite!



	ldy	#$00
.setup_sprite_pos0
	ldx	#$00
.setup_sprite_pos1
	phx
	phy
	spr_set sprite_no,satb
	spr_x sx
	spr_y sy
	spr_pattern spr_vram_point
	spr_ctrl  #SIZE_MASK|FLIP_MASK,#SIZE_32x32|NO_FLIP
	spr_pri   #1
	spr_pal   #0
;--------------------
	addw	#$20,sx
	inc	sprite_no
	addw	#$0008,spr_vram_point

	ply
	plx
	inx
	cpx	#08			;8 per row
	beq	.setup_change_y1
	jmp	.setup_sprite_pos1
.setup_change_y1
	subw	#$100,sx		;Go back to left side.
	addw	#$20,sy
	iny
	cpy	#07			;7 rows?
	beq	.setup_sprite_pos2
	jmp	.setup_sprite_pos0
;-------------------- 1st column is done!
.setup_sprite_pos2


	ldx	#$00
.setup_sprite_pos3
	phx
	phy
	spr_set sprite_no,satb
	spr_x sx
	spr_y sy
	spr_pattern spr_vram_point
	spr_ctrl  #SIZE_MASK|FLIP_MASK,#SIZE_32x16|NO_FLIP
	spr_pri   #1
	spr_pal   #0
;--------------------
	addw	#$20,sx
	inc	sprite_no
	addw	#4,spr_vram_point
	ply
	plx
	inx
	cpx	#08			;8 per row
	beq	.setup_change_y2
	jmp	.setup_sprite_pos3
.setup_change_y2

	rts


Position_Sprite_0:	;Takes position in A
	pha
	st0	#0		;VRAM Write reg
	stw	#$4300,video_data
	st0	#2
	pla
	sta     video_data
	stz	video_data+1
	rts


Update_Satb_BLOCKTRANSFER:
	stw   #SATB_VRAM,<_di	;Default SATB location
	jsr	set_write	;Load up into latch
	tia   satb,$0002,$0200	;BLOCK TRANSFER INSTRUCTION!
				;Block transfer 512 bytes...
				;from RAM to VRAM thru $0002!
			;MUCH more efficient than the MagicKit code!
	st0	#$13	;Sprite transfer DMA
	stw	#SATB_VRAM,$0002	;Copy the SATB __ONCE!!__
	rts



SprPal:
	.dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0	;one blank one!
	.incpal "GFX\Spr-Palettes.pcx",1,14
	.incpal "GFX\HiChewSPR.pcx",0,1